#include <random> // tratamento decente de variáveis aleatórias c++11

#define GAZ_BUFFSIZE  100 // buffer padrão para pipe e inicial char *

bool is_integer(const char *s) {
  if(strlen(s) == 0 || ((!isdigit(s[0])) && (s[0] != '-') && (s[0] != '+'))) return false ;

  char * p ;
  strtol(s, &p, 10) ;

  return (*p == 0) ;
} 

class RANDOM_t {
    std::random_device rd;
    std::mt19937_64 *dmt;
    std::mt19937_64 *mt;
    std::uniform_int_distribution<int> *dist;
    int seed;
    bool has_seed;
  public:
    // construtor
    RANDOM_t (void) {
      // <random>
      this->has_seed = false;
      this->seed = -1;
      this->dmt = new std::mt19937_64(this->rd());
      this->mt = new std::mt19937_64(1999);
      this->dist = new std::uniform_int_distribution<int>(0, 99);
    }

    RANDOM_t (int seed) {
      // <random>
      if (seed < 0) {
        this->has_seed = false;
        this->seed = -1;
        this->dmt = new std::mt19937_64(this->rd());
        this->mt = new std::mt19937_64(1999);
        this->dist = new std::uniform_int_distribution<int>(0, 99);
      } else {
        this->has_seed = true;
        this->seed = seed;
        this->dmt = new std::mt19937_64(this->rd());
        this->mt = new std::mt19937_64(seed);
        this->dist = new std::uniform_int_distribution<int>(0, 99);
      }
    }

    // destrutor
    ~RANDOM_t (void) {
      // <random>
      delete this->dmt;
      delete this->mt;
      delete this->dist;
    }

    void criaDist(int min, int max) {
      delete this->dist;
      this->dist = new std::uniform_int_distribution<int>(min, max);
    }

    int aleatorio(void) {
      if (this->has_seed) return (*(this->dist))((*(this->mt)));
      return (*(this->dist))((*(this->dmt)));
    }
};


